'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NanoEventEmitter = function () {
	function NanoEventEmitter() {
		(0, _classCallCheck3.default)(this, NanoEventEmitter);
		this.observers = {};
	}

	(0, _createClass3.default)(NanoEventEmitter, [{
		key: 'on',
		value: function on(eventNames, listener) {
			var _this = this;

			var events = Array.isArray(eventNames) ? eventNames : eventNames.split(' ');

			events.forEach(function (event) {
				_this.observers[event] = _this.observers[event] || [];
				_this.observers[event].push(listener);
			});
		}
	}, {
		key: 'off',
		value: function off(event, listener) {
			if (typeof this.observers[event] === 'undefined') {
				return;
			}

			if (typeof listener === 'undefined') {
				delete this.observers[event];
				return;
			}

			var index = this.observers[event].indexOf(listener);

			if (index > -1) {
				this.observers[event].splice(index, 1);
			}
		}
	}, {
		key: 'emit',
		value: function emit(event) {
			for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
				args[_key - 1] = arguments[_key];
			}

			if (typeof this.observers[event] === 'undefined') {
				return;
			}

			this.observers[event].forEach(function (observer) {
				return observer.apply(undefined, args);
			});
		}
	}]);
	return NanoEventEmitter;
}();

module.exports = NanoEventEmitter;
//# sourceMappingURL=index.js.map